package edu.nyu.scps.etch;

import android.app.Fragment;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;

class RetainedFragment extends Fragment {
	final Path path = new Path();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//This Fragment will outlive the Activity that created it.
		setRetainInstance(true);
	}

	Path getPath() {	//getter
		return path;
	}
}

public class EtchView extends View {
	final Paint paint = new Paint(Paint.ANTI_ALIAS_FLAG);
	final Path path;	//a reference to the Path that lives in the Fragment.

	public EtchView(Context context, RetainedFragment retainedFragment) {
		super(context);
		path = retainedFragment.getPath();

		paint.setColor(Color.BLACK);
		paint.setStyle(Paint.Style.STROKE);
		paint.setStrokeWidth(0);	//hairline

		setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				switch(event.getAction()) {
				case MotionEvent.ACTION_DOWN:
					EtchView.this.path.moveTo(event.getX(), event.getY());
					break;

				case MotionEvent.ACTION_MOVE:
					EtchView.this.path.lineTo(event.getX(), event.getY());
					break;

				default:
					return false;
				}

				invalidate();	//call onDraw
				return true;
			}
		});
	}

	@Override
	protected void onDraw(Canvas canvas) {
		canvas.drawColor(Color.WHITE);	//background
		canvas.drawPath(path, paint);
	}

}